// This is my version of the well known sinewave animation.  I have tried to keep it simple and understandable. 

void sinewave(int repeat) {
  for (int reps =0; reps<repeat; reps++){
    if (runMode > 0) {break;} // drop out if mode changes 
    for (int i=0; i<314; i++){   //it takes 314 steps to complete one full cycle
      getColor(i*6/10, 4); // get a rainbow color.  We need to go through all 189 color over the course of one full cycle. 
      for (byte xx=0; xx<4; xx++){ // for 1 quadrant of the cube
        for (byte yy=0; yy<4; yy++){
          // the next line is the guts of the calculation, where the z value is calculated both as a function of i and distance 
          // from center of cube.  The calculation is time consuming, so we calculate it for only one quadrant and 
          // then reflect it onto the other 3 quadrants.
          z=((byte)((4+sin(sqrt((3.5-xx)*(3.5-xx)+(3.5-yy)*(3.5-yy))/1.3+(float)i/50)*4))); // the actual z calculation
          LED(xx,yy, z, myred,mygreen,myblue); // put z into the proper place for each position in quadrant 1
          LED(7-xx,7-yy, z, myred,mygreen,myblue); // put z into the proper place for each position in quatrant 3
          LED(7-xx,yy, z, myred,mygreen,myblue);  // put z into the proper place for each position in quatrant 2
          LED(xx,7-yy, z, myred,mygreen,myblue);  // put z into the proper place for each position in quatrant 4  
        }
      }
      if ((i % 10)==0){  // We clear the cube, but only once every 10 steps.   This is OK, as the cube is refleshed only every 8 msec.                  
        clearCube();    // and this loops runs much faster than that.  Animation is much brighter and doesn't flcker as a result.
      }                 // Interestingly, this infrequent clearing of the cube doesn't start to produce any noticable distortion  
                        // until we get up to once every 50 steps!! 
    }
  }
  clearCube();
}

